package rounding_functions;

use strict;
use Carp("cluck");
use warnings;
use POSIX qw(floor ceil fmod);
use Math::Trig qw(pi);

require Exporter;
our @ISA = ("Exporter");

our @EXPORT = qw(round rounded_time_string round_to_mult minus_180_to_180 minus_pi_to_pi);

sub round {
	my $num = shift;
	return int ($num + 0.5 * ($num <=> 0));
}

sub round_to_mult {
	my $num = shift;
	my $mult = shift;
	return $mult * round($num/$mult);
}

sub minus_180_to_180 {
    my $num = shift;
    while ($num > 180) {
		$num -= 360;
	}
	while ($num < -180) {
		$num += 360;
	}
	return $num;
}

my $pi2 = 2*pi;

sub minus_pi_to_pi {
    my $num = shift;
    while ($num > pi) {
		$num -= $pi2;
	}
	while ($num < -(pi)) {
		$num += $pi2;
	}
	return $num;
}

sub rounded_time_string {
	# turns floating point secs into stringified hh:mm:ss with ss rounded to nearest int
	my $secs = shift;
	my $hours = floor($secs/3600);
	my $hours_string = sprintf '%02d:',$hours;
	$secs = $secs - $hours*3600;
	my $mins = floor($secs/60);;
	my $mins_string = sprintf '%02d:', $mins;
	my $secs_string = sprintf '%02d', floor($secs - $mins*60 + 0.5);
	return $hours_string.$mins_string.$secs_string;
}

1;

